unit AT89LP4052dm;

interface

uses
   Windows, Messages, SysUtils, Classes, StdCtrls,
   Graphics, Controls, Forms, Dialogs, inifiles,
   math, menus, assu, simu, oszu;

{$i sfrdef.pic}
type

   TAT89LP4052 =
   class(TDataModule)
      procedure   DataModuleCreate(Sender: TObject);
   private
      procedure   ProzClick(Sender: TObject);
   public
   end;

var
   AT89LP4052: TAT89LP4052;

implementation

{$R *.DFM}

procedure pxm0(prt: byte; wrt: byte);
var
   b:       integer;
begin
   for b := 0 to 7
   do begin
      simf.ptsps(wrk.sf2p[prt + b], 4, (wrt and (1 shl b) > 0));
   end;
end;

procedure pxm1(prt: byte; wrt: byte);
var
   b:       integer;
begin
   for b := 0 to 7
   do begin
      simf.ptsps(wrk.sf2p[prt + b], 8, (wrt and (1 shl b) > 0));
   end;
end;

//---------------------------------------
// set sfr byte
procedure ssfr(byt, wrt: byte);
var
    w:          word;
begin
   case byt of
   _P1M0:  
      begin
         wrk.sfrs[byt] := wrt;
         pxm0(_P1, wrt);
         simf.ptwrt();
      end;
   _P1M1:  
      begin
         wrk.sfrs[byt] := wrt;
         pxm1(_P1, wrt);
         simf.ptwrt();
      end;
   _P3M0:  
      begin
         wrk.sfrs[byt] := wrt;
         pxm0(_P3, wrt);
         simf.ptwrt();
      end;
   _P3M1:  
      begin
         wrk.sfrs[byt] := wrt;
         pxm1(_P3, wrt);
         simf.ptwrt();
      end;
   _SBUF:
      begin
         case wrk.sfrs[_SCON] and $c0 of
         $00:
            begin
					wrk.scow := 16 * 9;
               wrk.sbyt(wrt);
            end;
         $40:
				begin
					wrk.scow := 16 * 10;
					wrk.sbyt(wrt);
            end;
         $80,
         $C0:
            begin
					wrk.scow := 16 * 11;
               wrk.sbyt(wrt + byte(wrk.bitg(_TB8)) shl 8);
            end;
         end;
      end;
   _IE,
   _IP,
   _IPH:
      begin
         wrk.sfrs[byt] := wrt;
         wrk.ints := true;
         w := wrk.sfrs[_IE]
               and (255 - wrk.sfrs[_IP])
              and (255 - wrk.sfrs[_IPH]);
         wrk.iswt[ 1 ,_IE0] := (w and  1 ) > 0;
         wrk.iswt[ 1 ,_TF0] := (w and  2 ) > 0;
         wrk.iswt[ 1 ,_IE1] := (w and  4 ) > 0;
         wrk.iswt[ 1 ,_TF1] := (w and  8 ) > 0;
         wrk.iswt[ 1 ,_RI] := (w and  16 ) > 0;
         wrk.iswt[ 1 ,_TI] := (w and  16 ) > 0;
         wrk.iswt[ 1 ,_COMP] := (w and  64 ) > 0;
         w := wrk.sfrs[_IE]
               and wrk.sfrs[_IP]
              and (255 - wrk.sfrs[_IPH]);
         wrk.iswt[ 2 ,_IE0] := (w and  1 ) > 0;
         wrk.iswt[ 2 ,_TF0] := (w and  2 ) > 0;
         wrk.iswt[ 2 ,_IE1] := (w and  4 ) > 0;
         wrk.iswt[ 2 ,_TF1] := (w and  8 ) > 0;
         wrk.iswt[ 2 ,_RI] := (w and  16 ) > 0;
         wrk.iswt[ 2 ,_TI] := (w and  16 ) > 0;
         wrk.iswt[ 2 ,_COMP] := (w and  64 ) > 0;
         w := wrk.sfrs[_IE]
               and (255 - wrk.sfrs[_IP])
               and wrk.sfrs[_IPH];
         wrk.iswt[ 3 ,_IE0] := (w and  1 ) > 0;
         wrk.iswt[ 3 ,_TF0] := (w and  2 ) > 0;
         wrk.iswt[ 3 ,_IE1] := (w and  4 ) > 0;
         wrk.iswt[ 3 ,_TF1] := (w and  8 ) > 0;
         wrk.iswt[ 3 ,_RI] := (w and  16 ) > 0;
         wrk.iswt[ 3 ,_TI] := (w and  16 ) > 0;
         wrk.iswt[ 3 ,_COMP] := (w and  64 ) > 0;
         w := wrk.sfrs[_IE]
               and wrk.sfrs[_IP]
               and wrk.sfrs[_IPH];
         wrk.iswt[ 4 ,_IE0] := (w and  1 ) > 0;
         wrk.iswt[ 4 ,_TF0] := (w and  2 ) > 0;
         wrk.iswt[ 4 ,_IE1] := (w and  4 ) > 0;
         wrk.iswt[ 4 ,_TF1] := (w and  8 ) > 0;
         wrk.iswt[ 4 ,_RI] := (w and  16 ) > 0;
         wrk.iswt[ 4 ,_TI] := (w and  16 ) > 0;
         wrk.iswt[ 4 ,_COMP] := (w and  64 ) > 0;
      end;
   else
      begin
         wrk.sfrs[byt] := wrt;
      end;
   end;
end;

//---------------------------------------
// interrupt verarbeitung
procedure tint();
var
   i:       integer;
begin
   wrk.ibit := 0;
   if wrk.ints
   then begin
      wrk.ints := false;
      exit;
   end;
   for i := 4 downto wrk.intl + 1
   do begin
      if wrk.bitg(_IE0)
      and wrk.iswt[i, _IE0]
      then begin
         wrk.ibit := _IE0;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr shr 8;
         wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
         wrk.padr := $03;
         if wrk.bitg(_IT0)
         then wrk.bitm(_IE0, false);
         wrk.intl := i;
         wrk.intf[wrk.intl] :=  6 ;
         wrk.intu[i] := true;
         break;
      end;
      if wrk.bitg(_TF0)
      and wrk.iswt[i, _TF0]
      then begin
         wrk.ibit := _TF0;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr shr 8;
         wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
         wrk.padr := $0B;
         wrk.bitm(_TF0, false);
         wrk.intl := i;
         wrk.intf[wrk.intl] :=  5 ;
         wrk.intu[i] := true;
         break;
      end;
      if wrk.bitg(_IE1)
      and wrk.iswt[i, _IE1]
      then begin
         wrk.ibit := _IE1;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr shr 8;
         wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
         wrk.padr := $13;
         if wrk.bitg(_IT1)
         then wrk.bitm(_IE1, false);
         wrk.intl := i;
         wrk.intf[wrk.intl] :=  4 ;
         wrk.intu[i] := true;
         break;
      end;
      if wrk.bitg(_TF1)
      and wrk.iswt[i, _TF1]
      then begin
         wrk.ibit := _TF1;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr shr 8;
         wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
         wrk.padr := $1B;
         wrk.bitm(_TF1, false);
         wrk.intl := i;
         wrk.intf[wrk.intl] :=  3 ;
         wrk.intu[i] := true;
         break;
      end;
      if wrk.bitg(_RI)
      and wrk.iswt[i, _RI]
      then begin
         wrk.ibit := _RI;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr and $ff;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr shr 8;
         wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
         wrk.padr := $23;
         wrk.intl := i;
         wrk.intf[wrk.intl] :=  2 ;
         wrk.intu[i] := true;
         break;
      end;
      if wrk.bitg(_TI)
      and wrk.iswt[i, _TI]
      then begin
         wrk.ibit := _TI;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr shr 8;
         wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
         wrk.padr := $23;
         wrk.intl := i;
         wrk.intf[wrk.intl] :=  2 ;
         wrk.intu[i] := true;
         break;
      end;
      if wrk.bitg(_COMP)
      and wrk.iswt[i, _COMP]
      then begin
         wrk.ibit := _COMP;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr;
         inc(wrk.sfrs[_SP]);
         wrk.iram[wrk.sfrs[_SP]] := wrk.padr shr 8;
         wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
         wrk.padr := $33;
         wrk.bitm(_COMP, false);
         wrk.intl := i;
         wrk.intf[wrk.intl] :=  0 ;
         wrk.intu[i] := true;
         break;
      end;
   end;
end;

//---------------------------------------
// SFR Reset
procedure rcpu();
var
   i:       integer;
begin
   for i := low(wrk.pmod) to high(wrk.pmod)
   do begin
      wrk.pmod[i] := 3;
   end;
   ssfr(_SP, $07);
   ssfr(_DPL, $00);
   ssfr(_DPH, $00);
   ssfr(_SPDR, $00);
   ssfr(_PCON, $30);
   ssfr(_TCON, $00);
   ssfr(_TMOD, $00);
   ssfr(_TL0, $00);
   ssfr(_TL1, $00);
   ssfr(_TH0, $00);
   ssfr(_TH1, $00);
   ssfr(_P1, $FF);
   ssfr(_TCONB, $24);
   ssfr(_SCON, $00);
   ssfr(_IE, $00);
   ssfr(_P3, $FF);
   ssfr(_IP, $00);
   ssfr(_P1M0, $ff);
   ssfr(_P1M1, $00);
   ssfr(_P3M0, $ff);
   ssfr(_P3M1, $00);
   ssfr(_PSW, $00);
   ssfr(_A, $00);
   ssfr(_ACC, $00);
   ssfr(_B, $00);
end;

//---------------------------------------
procedure TAT89LP4052.prozclick(sender: tobject);
var
   i:       integer;
   mi:      TMenuItem;
begin
   tmenuitem(sender).checked := true;
   assf.Proz1.Tag := tmenuitem(sender).tag;
   assf.sim1.Enabled := false;
   While oszf.pm.Items.Count > 1
   do oszf.pm.Items[1].Free;

   for i := low(wrk.sf2p) to high(wrk.sf2p)
   do begin
      wrk.sf2p[i] := 0;
   end;
   for i := low(wrk.pi2i) to high(wrk.pi2i)
   do begin
      wrk.pi2i[i] := 0;
      wrk.pi2s[i] := 0;
      wrk.pi2n[i] := '';
   end;

   wrk.proz := 'AT89LP4052';
   wrk.clcy :=  1 ;

   wrk.clkt[ $11] :=  3 ;
   wrk.clkt[ $31] :=  3 ;
   wrk.clkt[ $51] :=  3 ;
   wrk.clkt[ $71] :=  3 ;
   wrk.clkt[ $91] :=  3 ;
   wrk.clkt[ $B1] :=  3 ;
   wrk.clkt[ $D1] :=  3 ;
   wrk.clkt[ $F1] :=  3 ;

   wrk.clkt[ $26] :=  2 ;
   wrk.clkt[ $27] :=  2 ;

   wrk.clkt[ $28] :=  1 ;
   wrk.clkt[ $29] :=  1 ;
   wrk.clkt[ $2A] :=  1 ;
   wrk.clkt[ $2B] :=  1 ;
   wrk.clkt[ $2C] :=  1 ;
   wrk.clkt[ $2D] :=  1 ;
   wrk.clkt[ $2E] :=  1 ;
   wrk.clkt[ $2F] :=  1 ;
   wrk.clkt[$24] :=  2 ;
   wrk.clkt[$25] :=  2 ;

   wrk.clkt[ $36] :=  2 ;
   wrk.clkt[ $37] :=  2 ;

   wrk.clkt[ $38] :=  1 ;
   wrk.clkt[ $39] :=  1 ;
   wrk.clkt[ $3A] :=  1 ;
   wrk.clkt[ $3B] :=  1 ;
   wrk.clkt[ $3C] :=  1 ;
   wrk.clkt[ $3D] :=  1 ;
   wrk.clkt[ $3E] :=  1 ;
   wrk.clkt[ $3F] :=  1 ;
   wrk.clkt[$34] :=  2 ;
   wrk.clkt[$35] :=  2 ;

   wrk.clkt[ $1] :=  3 ;
   wrk.clkt[ $21] :=  3 ;
   wrk.clkt[ $41] :=  3 ;
   wrk.clkt[ $61] :=  3 ;
   wrk.clkt[ $81] :=  3 ;
   wrk.clkt[ $A1] :=  3 ;
   wrk.clkt[ $C1] :=  3 ;
   wrk.clkt[ $E1] :=  3 ;

   wrk.clkt[ $56] :=  2 ;
   wrk.clkt[ $57] :=  2 ;

   wrk.clkt[ $58] :=  1 ;
   wrk.clkt[ $59] :=  1 ;
   wrk.clkt[ $5A] :=  1 ;
   wrk.clkt[ $5B] :=  1 ;
   wrk.clkt[ $5C] :=  1 ;
   wrk.clkt[ $5D] :=  1 ;
   wrk.clkt[ $5E] :=  1 ;
   wrk.clkt[ $5F] :=  1 ;
   wrk.clkt[$54] :=  2 ;
   wrk.clkt[$55] :=  2 ;
   wrk.clkt[$B0] :=  2 ;
   wrk.clkt[$82] :=  2 ;
   wrk.clkt[$52] :=  2 ;
   wrk.clkt[$53] :=  3 ;
   wrk.clkt[$B4] :=  4 ;
   wrk.clkt[$B5] :=  4 ;

   wrk.clkt[ $B6] :=  4 ;
   wrk.clkt[ $B7] :=  4 ;

   wrk.clkt[ $B8] :=  4 ;
   wrk.clkt[ $B9] :=  4 ;
   wrk.clkt[ $BA] :=  4 ;
   wrk.clkt[ $BB] :=  4 ;
   wrk.clkt[ $BC] :=  4 ;
   wrk.clkt[ $BD] :=  4 ;
   wrk.clkt[ $BE] :=  4 ;
   wrk.clkt[ $BF] :=  4 ;
   wrk.clkt[$C3] :=  1 ;
   wrk.clkt[$E4] :=  1 ;
   wrk.clkt[$C2] :=  2 ;
   wrk.clkt[$B3] :=  1 ;
   wrk.clkt[$F4] :=  1 ;
   wrk.clkt[$B2] :=  2 ;
   wrk.clkt[$D4] :=  1 ;
   wrk.clkt[$14] :=  1 ;

   wrk.clkt[ $16] :=  2 ;
   wrk.clkt[ $17] :=  2 ;

   wrk.clkt[ $18] :=  1 ;
   wrk.clkt[ $19] :=  1 ;
   wrk.clkt[ $1A] :=  1 ;
   wrk.clkt[ $1B] :=  1 ;
   wrk.clkt[ $1C] :=  1 ;
   wrk.clkt[ $1D] :=  1 ;
   wrk.clkt[ $1E] :=  1 ;
   wrk.clkt[ $1F] :=  1 ;
   wrk.clkt[$15] :=  2 ;
   wrk.clkt[$84] :=  4 ;

   wrk.clkt[ $D8] :=  3 ;
   wrk.clkt[ $D9] :=  3 ;
   wrk.clkt[ $DA] :=  3 ;
   wrk.clkt[ $DB] :=  3 ;
   wrk.clkt[ $DC] :=  3 ;
   wrk.clkt[ $DD] :=  3 ;
   wrk.clkt[ $DE] :=  3 ;
   wrk.clkt[ $DF] :=  3 ;
   wrk.clkt[$D5] :=  4 ;
   wrk.clkt[$A5] := 0;
   wrk.clkt[$04] :=  1 ;

   wrk.clkt[ $6] :=  2 ;
   wrk.clkt[ $7] :=  2 ;

   wrk.clkt[ $8] :=  1 ;
   wrk.clkt[ $9] :=  1 ;
   wrk.clkt[ $A] :=  1 ;
   wrk.clkt[ $B] :=  1 ;
   wrk.clkt[ $C] :=  1 ;
   wrk.clkt[ $D] :=  1 ;
   wrk.clkt[ $E] :=  1 ;
   wrk.clkt[ $F] :=  1 ;
   wrk.clkt[$A3] :=  2 ;
   wrk.clkt[$05] :=  2 ;
   wrk.clkt[$20] :=  4 ;
   wrk.clkt[$10] :=  4 ;
   wrk.clkt[$40] :=  3 ;
   wrk.clkt[$73] :=  2 ;
   wrk.clkt[$30] :=  4 ;
   wrk.clkt[$50] :=  3 ;
   wrk.clkt[$70] :=  3 ;
   wrk.clkt[$60] :=  3 ;
   wrk.clkt[$12] :=  4 ;
   wrk.clkt[$02] :=  4 ;

   wrk.clkt[ $E6] :=  2 ;
   wrk.clkt[ $E7] :=  2 ;

   wrk.clkt[ $E8] :=  1 ;
   wrk.clkt[ $E9] :=  1 ;
   wrk.clkt[ $EA] :=  1 ;
   wrk.clkt[ $EB] :=  1 ;
   wrk.clkt[ $EC] :=  1 ;
   wrk.clkt[ $ED] :=  1 ;
   wrk.clkt[ $EE] :=  1 ;
   wrk.clkt[ $EF] :=  1 ;

   wrk.clkt[ $F6] :=  1 ;
   wrk.clkt[ $F7] :=  1 ;

   wrk.clkt[ $F8] :=  1 ;
   wrk.clkt[ $F9] :=  1 ;
   wrk.clkt[ $FA] :=  1 ;
   wrk.clkt[ $FB] :=  1 ;
   wrk.clkt[ $FC] :=  1 ;
   wrk.clkt[ $FD] :=  1 ;
   wrk.clkt[ $FE] :=  1 ;
   wrk.clkt[ $FF] :=  1 ;
   wrk.clkt[$74] :=  2 ;

   wrk.clkt[ $76] :=  2 ;
   wrk.clkt[ $77] :=  2 ;

   wrk.clkt[ $78] :=  2 ;
   wrk.clkt[ $79] :=  2 ;
   wrk.clkt[ $7A] :=  2 ;
   wrk.clkt[ $7B] :=  2 ;
   wrk.clkt[ $7C] :=  2 ;
   wrk.clkt[ $7D] :=  2 ;
   wrk.clkt[ $7E] :=  2 ;
   wrk.clkt[ $7F] :=  2 ;
   wrk.clkt[$90] :=  3 ;
   wrk.clkt[$A2] :=  2 ;

   wrk.clkt[ $A6] :=  2 ;
   wrk.clkt[ $A7] :=  2 ;

   wrk.clkt[ $A8] :=  2 ;
   wrk.clkt[ $A9] :=  2 ;
   wrk.clkt[ $AA] :=  2 ;
   wrk.clkt[ $AB] :=  2 ;
   wrk.clkt[ $AC] :=  2 ;
   wrk.clkt[ $AD] :=  2 ;
   wrk.clkt[ $AE] :=  2 ;
   wrk.clkt[ $AF] :=  2 ;
   wrk.clkt[$E5] :=  2 ;

   wrk.clkt[ $86] :=  2 ;
   wrk.clkt[ $87] :=  2 ;

   wrk.clkt[ $88] :=  2 ;
   wrk.clkt[ $89] :=  2 ;
   wrk.clkt[ $8A] :=  2 ;
   wrk.clkt[ $8B] :=  2 ;
   wrk.clkt[ $8C] :=  2 ;
   wrk.clkt[ $8D] :=  2 ;
   wrk.clkt[ $8E] :=  2 ;
   wrk.clkt[ $8F] :=  2 ;
   wrk.clkt[$92] :=  2 ;
   wrk.clkt[$F5] :=  2 ;
   wrk.clkt[$75] :=  3 ;
   wrk.clkt[$85] :=  3 ;
   wrk.clkt[$83] :=  3 ;
   wrk.clkt[$93] :=  3 ;
   wrk.clkt[$E0] := 0;
   wrk.clkt[$E2] := 0;
   wrk.clkt[$F0] := 0;
   wrk.clkt[$F2] := 0;
   wrk.clkt[$A4] :=  2 ;
   wrk.clkt[$00] :=  1 ;

   wrk.clkt[ $46] :=  2 ;
   wrk.clkt[ $47] :=  2 ;

   wrk.clkt[ $48] :=  1 ;
   wrk.clkt[ $49] :=  1 ;
   wrk.clkt[ $4A] :=  1 ;
   wrk.clkt[ $4B] :=  1 ;
   wrk.clkt[ $4C] :=  1 ;
   wrk.clkt[ $4D] :=  1 ;
   wrk.clkt[ $4E] :=  1 ;
   wrk.clkt[ $4F] :=  1 ;
   wrk.clkt[$44] :=  2 ;
   wrk.clkt[$45] :=  2 ;
   wrk.clkt[$A0] :=  2 ;
   wrk.clkt[$72] :=  2 ;
   wrk.clkt[$42] :=  2 ;
   wrk.clkt[$43] :=  3 ;
   wrk.clkt[$D0] :=  2 ;
   wrk.clkt[$C0] :=  2 ;
   wrk.clkt[$22] :=  4 ;
   wrk.clkt[$32] :=  4 ;
   wrk.clkt[$23] :=  1 ;
   wrk.clkt[$33] :=  1 ;
   wrk.clkt[$03] :=  1 ;
   wrk.clkt[$13] :=  1 ;
   wrk.clkt[$D3] :=  1 ;
   wrk.clkt[$D2] :=  2 ;
   wrk.clkt[$80] :=  3 ;

   wrk.clkt[ $96] :=  2 ;
   wrk.clkt[ $97] :=  2 ;

   wrk.clkt[ $98] :=  1 ;
   wrk.clkt[ $99] :=  1 ;
   wrk.clkt[ $9A] :=  1 ;
   wrk.clkt[ $9B] :=  1 ;
   wrk.clkt[ $9C] :=  1 ;
   wrk.clkt[ $9D] :=  1 ;
   wrk.clkt[ $9E] :=  1 ;
   wrk.clkt[ $9F] :=  1 ;
   wrk.clkt[$94] :=  2 ;
   wrk.clkt[$95] :=  2 ;
   wrk.clkt[$C4] :=  1 ;

   wrk.clkt[ $C6] :=  2 ;
   wrk.clkt[ $C7] :=  2 ;

   wrk.clkt[ $C8] :=  1 ;
   wrk.clkt[ $C9] :=  1 ;
   wrk.clkt[ $CA] :=  1 ;
   wrk.clkt[ $CB] :=  1 ;
   wrk.clkt[ $CC] :=  1 ;
   wrk.clkt[ $CD] :=  1 ;
   wrk.clkt[ $CE] :=  1 ;
   wrk.clkt[ $CF] :=  1 ;
   wrk.clkt[$C5] :=  2 ;

   wrk.clkt[ $D6] :=  2 ;
   wrk.clkt[ $D7] :=  2 ;

   wrk.clkt[ $66] :=  2 ;
   wrk.clkt[ $67] :=  2 ;

   wrk.clkt[ $68] :=  1 ;
   wrk.clkt[ $69] :=  1 ;
   wrk.clkt[ $6A] :=  1 ;
   wrk.clkt[ $6B] :=  1 ;
   wrk.clkt[ $6C] :=  1 ;
   wrk.clkt[ $6D] :=  1 ;
   wrk.clkt[ $6E] :=  1 ;
   wrk.clkt[ $6F] :=  1 ;
   wrk.clkt[$64] :=  2 ;
   wrk.clkt[$65] :=  2 ;
   wrk.clkt[$62] :=  2 ;
   wrk.clkt[$63] :=  3 ;

   for i := 128 To 255
   do wrk.sfrd[i] := false;

   wrk.sfrd[$81] := true;
   wrk.sfrd[$82] := true;
   wrk.sfrd[$83] := true;
   wrk.sfrd[$86] := true;
   wrk.sfrd[$87] := true;
   wrk.sfrd[$88] := true;
   wrk.sfrd[$89] := true;
   wrk.sfrd[$8A] := true;
   wrk.sfrd[$8B] := true;
   wrk.sfrd[$8C] := true;
   wrk.sfrd[$8D] := true;
   wrk.sfrd[$90] := true;
   wrk.sfrd[$91] := true;
   wrk.sfrd[$92] := true;
   wrk.sfrd[$93] := true;
   wrk.sfrd[$94] := true;
   wrk.sfrd[$95] := true;
   wrk.sfrd[$97] := true;
   wrk.sfrd[$98] := true;
   wrk.sfrd[$99] := true;
   wrk.sfrd[$A6] := true;
   wrk.sfrd[$A7] := true;
   wrk.sfrd[$A8] := true;
   wrk.sfrd[$A9] := true;
   wrk.sfrd[$AA] := true;
   wrk.sfrd[$B0] := true;
   wrk.sfrd[$B7] := true;
   wrk.sfrd[$B8] := true;
   wrk.sfrd[$B9] := true;
   wrk.sfrd[$C2] := true;
   wrk.sfrd[$C3] := true;
   wrk.sfrd[$C6] := true;
   wrk.sfrd[$C7] := true;
   wrk.sfrd[$D0] := true;
   wrk.sfrd[$D5] := true;
   wrk.sfrd[$E0] := true;
   wrk.sfrd[$E0] := true;
   wrk.sfrd[$F0] := true;

   wrk.pi2s[ 1 ] :=  1 ;
   wrk.pi2s[ 4 ] :=  4 ;
   wrk.pi2s[ 5 ] :=  5 ;
   wrk.pi2s[ 10 ] :=  10 ;
   wrk.pi2s[ 20 ] :=  20 ;
   wrk.pi2s[ 12 ] := $90;
   wrk.pi2s[ 13 ] := $91;
   wrk.pi2s[ 14 ] := $92;
   wrk.pi2s[ 15 ] := $93;
   wrk.pi2s[ 16 ] := $94;
   wrk.pi2s[ 17 ] := $95;
   wrk.pi2s[ 18 ] := $96;
   wrk.pi2s[ 19 ] := $97;
   wrk.pi2s[ 2 ] := $B0;
   wrk.pi2s[ 3 ] := $B1;
   wrk.pi2s[ 6 ] := $B2;
   wrk.pi2s[ 7 ] := $B3;
   wrk.pi2s[ 8 ] := $B4;
   wrk.pi2s[ 8 ] := $B4;
   wrk.pi2s[ 9 ] := $B5;
   wrk.pi2s[ 9 ] := $B5;
   wrk.pi2s[ 11 ] := $B7;

   wrk.sf2p[$90] :=  12 ;
   wrk.sf2p[$91] :=  13 ;
   wrk.sf2p[$92] :=  14 ;
   wrk.sf2p[$93] :=  15 ;
   wrk.sf2p[$94] :=  16 ;
   wrk.sf2p[$95] :=  17 ;
   wrk.sf2p[$96] :=  18 ;
   wrk.sf2p[$97] :=  19 ;
   wrk.sf2p[$B0] :=  2 ;
   wrk.sf2p[$B1] :=  3 ;
   wrk.sf2p[$B2] :=  6 ;
   wrk.sf2p[$B3] :=  7 ;
   wrk.sf2p[$B4] :=  8 ;
   wrk.sf2p[$B4] :=  8 ;
   wrk.sf2p[$B5] :=  9 ;
   wrk.sf2p[$B5] :=  9 ;
   wrk.sf2p[$B7] :=  11 ;

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 2;
   mi.Caption := 'Pin 2';
   mi.Name := 'Pin2';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 3;
   mi.Caption := 'Pin 3';
   mi.Name := 'Pin3';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 6;
   mi.Caption := 'Pin 6';
   mi.Name := 'Pin6';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 7;
   mi.Caption := 'Pin 7';
   mi.Name := 'Pin7';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 8;
   mi.Caption := 'Pin 8';
   mi.Name := 'Pin8';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 9;
   mi.Caption := 'Pin 9';
   mi.Name := 'Pin9';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 11;
   mi.Caption := 'Pin 11';
   mi.Name := 'Pin11';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 12;
   mi.Caption := 'Pin 12';
   mi.Name := 'Pin12';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 13;
   mi.Caption := 'Pin 13';
   mi.Name := 'Pin13';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 14;
   mi.Caption := 'Pin 14';
   mi.Name := 'Pin14';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 15;
   mi.Caption := 'Pin 15';
   mi.Name := 'Pin15';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 16;
   mi.Caption := 'Pin 16';
   mi.Name := 'Pin16';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 17;
   mi.Caption := 'Pin 17';
   mi.Name := 'Pin17';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 18;
   mi.Caption := 'Pin 18';
   mi.Name := 'Pin18';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   assf.sim1.Enabled := true;
   mi := tmenuitem.Create(self);
   mi.Tag := 19;
   mi.Caption := 'Pin 19';
   mi.Name := 'Pin19';
   mi.onclick := oszf.pm.Items[0].OnClick;
   Oszf.pm.Items.Add(mi);

   wrk.pi2i[ 6 ] := _IE0;
   wrk.pi2i[ 7 ] := _IE1;

   wrk.roms := 4128 ;
   wrk.rams := 256 ;
   wrk.pins := 20 ;

   wrk.bitg := nil;
   wrk.bitm := nil;
   wrk.sbyt := nil;
   wrk.ssfr := ssfr;
   wrk.tint := tint;
   wrk.rcpu := rcpu;

   assf.sim1.enabled := true;

end;

procedure TAT89LP4052.DataModuleCreate(Sender: TObject);
var
   mi:     tmenuitem;
begin
   mi := tmenuitem.Create(self);
   mi.Caption := 'AT89LP4052';
   mi.name := mi.caption;
   mi.RadioItem := true;
   mi.GroupIndex := 1;
   mi.Tag := 1;
   mi.onclick := prozclick;
   assf.Proz1.Add(mi);
end;

end.
