unit binhexu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Menus;

type
	Tbh = class(TDataModule)
	private		{ Private-Deklarationen}
	public      { Public-Deklarationen}
		procedure bin(f: string);
		procedure elektor_hex(f: string);
		procedure intel_hex(f: string);
		procedure motorola_mhx(f: string);
		procedure motorola_ms1(f: string);
		procedure motorola_ms2(f: string);
		procedure motorola_ms3(f: string);
		procedure motorola_s1(f: string);
		procedure motorola_s2(f: string);
		procedure motorola_s3(f: string);
		procedure bin_read(f: string);
		procedure hex_read(f: string);
	end;

var
	bh: Tbh;
	fnam:		string;
	s:			string;
	ts:		TStringList;
	cs:		word;
	i:			longword;
	j:			integer;

implementation

uses assu;

{$R *.DFM}

procedure nobin;
begin
	messagedlg('Abbruch wegen Breakpoint', mterror, [mbok], 0);
end;

procedure addmi(n: string; p: TNotifyEvent);
var
	cmi:		TMenuItem;
begin
	cmi := TMenuItem.Create(assf);
	cmi.Caption := n;
	cmi.OnClick := p;
end;

procedure Tbh.BIN(f: string);
var
	an,
	en,
	i,
	j:		integer;
	fi:	file;
	b:		array [0..511] of byte;
	s:		string;
begin
	an := strtoint(assf.lrb.Caption);
	en := wrk.tabh;
	if assf.cb1.Checked
	and (wrk.roms > 128)
	then en := an + wrk.roms;
	s := changefileext(f, '.bin');
	assignfile(fi, s);
	rewrite(fi, 1);
	j := 0;
	for i := an to en - 1
	do begin
		if wrk.brtr[i] and byteu = 0
		then b[j] := $FF
		else b[j] := wrk.prog[i];
		inc(j);
		if j > sizeof(b) - 1
		then begin
			blockwrite(fi, b, sizeof(b));
			j := 0;
		end;
	end;
	if j > 0
	then blockwrite(fi, b, j);
	closefile(fi);
end;

procedure Tbh.elektor_hex(f: string);
	procedure outline;
	begin
		s := format('%2.2x %4.4x:%s%4.4x',
				[length(s) div 3, j, s, cs]);
		ts.Add (s);
	end;
begin
	ts := TStringList.Create ;
	if uflags + mflags + rflags + aflags = 0
	then begin
		s := '';
		cs := 0;
		i := wrk.tabl;
		j := -1;
		while i < wrk.tabh
		do begin
			if wrk.brtr[i] and byteu > 0
			then begin
				if j = -1
				then j := i;
				s := s + format('%2.2x ', [wrk.prog[i]]);
				cs := cs + wrk.prog[i];
			end;
			if (length(s) > 47)
			or (wrk.brtr[i] and byteu = 0)
			then begin
				if s > ''
				then begin
					outline;
					j := -1;
					s := '';
					cs := 0;
				end;
			end;
			inc(i);
		end;
		if s > ''
		then begin
			outline;
		end;
		s := changefileext(f, '.hex');
		ts.SaveToFile(s);
	end;
	ts.free;
end;

procedure Tbh.intel_hex(f: string);
	procedure outline;
	begin
		cs := cs + (j shr 8) and $FF + j + length(s) div 2;
		s := format(':%2.2x%4.4x00%s%2.2x',
				[length(s) div 2, j, s, cs * -1 and $FF]);
		ts.Add (s);
	end;
begin
	ts := TStringList.Create ;
	if uflags + mflags + rflags + aflags = 0
	then begin
		s := '';
		cs := 0;
		i := wrk.tabl;
		j := -1;
		while i < wrk.tabh
		do begin
			if wrk.brtr[i] and byteu > 0
			then begin
				if j = -1
				then j := i;
				s := s + format('%2.2x', [wrk.prog[i]]);
				cs := cs + wrk.prog[i];
			end;
			if (length(s) > 31)
			or (wrk.brtr[i] and byteu = 0)
			then begin
				if s > ''
				then begin
					outline;
					j := -1;
					s := '';
					cs := 0;
				end;
			end;
			inc(i);
		end;
		if s > ''
		then begin
			outline;
		end;
		ts.Add (':00000001FF');
		s := changefileext(f, '.hex');
		ts.SaveToFile(s);
	end;
	ts.free;
end;

procedure mhex(t: byte; f: string);
var
	es,
	fs:	string;
	ls:	integer;
const
	fs1 = 'S%d%2.2x%4.4x%s%2.2x';
	fs2 = 'S%d%2.2x%6.6x%s%2.2x';
	fs3 = 'S%d%2.2x%8.8x%s%2.2x';

	function mhHdr: string;
	var
		i:		integer;
		s1,
		s2:	string;
	begin
		s1 := 'ASS51 - APE Soft';
		s2 := '';
		cs := 0;
		for i := 1 to length(s1)
		do begin
			s2 := s2 + format('%2.2x', [ord(s1[i])]);
			cs := cs + ord(s1[i]);
		end;
		mhHdr := s2;
	end;
	procedure outline(t: byte);
	begin
		cs := cs + ((j shr 16) and $FF)
					+ ((j shr 8) and $FF)
					+ (j and $FF);
		cs := cs + length(s) div 2 + ls;
		s := format(fs,
				[t, length(s) div 2 + ls, j, s, (cs and $FF) xor $FF]);
		ts.Add (s);
	end;
begin
	ts := TStringList.Create ;
	s := mhHdr;
	j := 0;
	fs := fs1;
	ls := 3;
	outline(0);

	case t of
	1: begin	fs := fs2;	es := '.mhx'; ls := 4; end;
	2: begin	fs := fs1;	es := '.ms1'; ls := 3; end;
	3: begin	fs := fs2;	es := '.ms2'; ls := 4; end;
	4: begin	fs := fs3;	es := '.ms3'; ls := 5; end;
	5: begin	fs := fs1;	es := '.s1'; ls := 3; end;
	6: begin	fs := fs2;	es := '.s2'; ls := 4; end;
	7: begin	fs := fs3;	es := '.s3'; ls := 5; end;
	end;
	if uflags + mflags + rflags + aflags = 0
	then begin
		s := '';
		cs := 0;
		i := wrk.tabl;
		j := -1;
		while i < wrk.tabh
		do begin
			if wrk.brtr[i] and byteu > 0
			then begin
				if j = -1
				then j := i;
				s := s + format('%2.2x', [wrk.prog[i]]);
				cs := cs + wrk.prog[i];
			end
			else begin
				if j = -1
				then j := i;
				s := s + 'FF';
				cs := cs + 255;
			end;
			if (length(s) > 31)
//			or (wrk.brtr[i] and byteu = 0)
			then begin
				if s > ''
				then begin
					outline(ls - 2);
					j := -1;
					s := '';
					cs := 0;
				end;
			end;
			inc(i);
		end;
		if s > ''
		then begin
			outline(ls - 2);
		end;
		s := '';
		cs := 0;
		j := wrk.tabh;
		outline(12 - ls);
		s := changefileext(f, es);
		ts.SaveToFile(s);
	end;
	ts.free;
end;

procedure Tbh.motorola_mhx(f: string);
begin
	mhex(1, f);
end;

procedure Tbh.motorola_ms1(f: string);
begin
	mhex(2, f);
end;

procedure Tbh.motorola_ms2(f: string);
begin
	mhex(3, f);
end;

procedure Tbh.motorola_ms3(f: string);
begin
	mhex(4, f);
end;

procedure Tbh.motorola_s1(f: string);
begin
	mhex(5, f);
end;

procedure Tbh.motorola_s2(f: string);
begin
	mhex(6, f);
end;

procedure Tbh.motorola_s3(f: string);
begin
	mhex(7, f);
end;

// Leseroutinen

procedure Tbh.BIN_read(f: string);
var
	j:		longint;
	i,
	p:		integer;
	fi:	file;
	b:		array [0..511] of byte;
begin
	assignfile(fi, f);
	reset(fi, 1);
	wrk.tabl := 0;
	wrk.tabh := 0;
	p := 0;
	while not eof(fi)
	do begin
		blockread(fi, b, sizeof(b), j);
		for i := 0 to j - 1
		do begin
			wrk.brtr[p] := 0;
			wrk.prog[p] := b[i];
			if wrk.prog[p] < $FF
			then begin
				wrk.brtr[p] := byteu;
				wrk.tabh := p;
			end;
			inc(p);
		end;
	end;
	closefile(fi);
end;

procedure Tbh.hex_read(f: string);
var
	i,
	j,
	p:		integer;
	fi:	textfile;
//	b:		array [0..511] of char;
	s:		string;
begin
	assignfile(fi, changefileext(f, '.hex'));
	reset(fi);
	wrk.tabl := 4096;
	wrk.tabh := 0;
	while not eof(fi)
	do begin
		readln(fi, s);
		if copy(s, 1, 1) = ':'
// intel   ':%2.2x%4.4x00%s%2.2x'
// length(s) div 2, j, s, cs * -1 and $FF]
		then begin     // intel
			p := strtoint('$' + copy(s, 2, 2));
			p := p * 2 + 10;
			i := 10;
		end
// elektor  '%2.2x %4.4x:%s%4.4x'
//      length(s) div 3, j, s, cs
		else begin     // elekt
			p := strtoint('$' + copy(s, 1, 2));
			p := p * 3 + 9;
			i := 9;
		end;
		j := strtoint('$' + copy(s, 4, 4));
		if j < wrk.tabl
		then wrk.tabl := j;
		while i < p
		do begin
			wrk.brtr[p] := 0;
			wrk.prog[j] := strtoint('$' + copy(s, i, 2));
			if wrk.prog[j] < $FF
			then begin
				wrk.brtr[j] := byteu;
				if j > wrk.tabh
				then wrk.tabh := j;
			end;
			inc(j);
			inc(i, 2);
			if copy(s, i, 1) = ' '
			then inc(i);
		end;
	end;
	closefile(fi);
end;

end.
