unit calcdm;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, StdCtrls,
	assu;

type
	Tcalc =
  	class(TDataModule)
		procedure 	DataModuleCreate(Sender: TObject);
	private		{ Private-Deklarationen }
		digithg,
		digithk,
		digitd,
		digito,
		digitb,
		opera:		set of char;
		klev:			byte;
		wnum:			string;
		wind:			integer;
		Fgetname:	tgetname;
		Ferrlst:		Terrlst;
		function		lev(o: char): byte;
		function 	act(o: char; w, nw: int64): int64;
		function 	ber(w: int64; o: char): int64;
		function 	numbin(s: string): int64;
		function 	numdec(s: string): int64;
		function 	numhex(s: string): int64;
		function 	numoct(s: string): int64;
	public 		{ Public-Deklarationen }
		property    getname:		tgetname read 	Fgetname
													write Fgetname;
		property    errlst:		terrlst	read 	Ferrlst
													write Ferrlst;
		function		adr(Input: string): 	integer; // tnametab;
	end;

var
  	calc: 		Tcalc;

implementation

{$R *.DFM}

function Tcalc.lev(o: char): byte;
begin
	case o of
	'>', '<': result := 1;
	'|', '&', '^': result := 2;
	'+', '-': result := 4;
	'*', '/': result := 3;
	else result := 0;
	end;
end;

function Tcalc.act(o: char; w, nw: int64): int64;
begin
	result := nw;
	case o of
	'<':  result := w shl nw;
	'>':  result := w shr nw;
	'+':  result := w + nw;
	'-':  result := w - nw;
	'*':  result := w * nw;
	'/':
		begin
			if nw = 0
			then begin
				errlst('Division / null', 'D');
				result := 1;
			end
			else result := w div nw;
		end;
	'|':  result := w or nw;
	'&':  result := w and nw;
	'^':  result := w xor nw;
	'#':  exit;
	end;
//	if assigned(memo)
//	then memo.lines.add(format('r %9d %s %9d = %d',
//					[w, o, nw, result]));
end;

function Tcalc.numhex(s: string): int64;
var
	i:			integer;
begin
	result := 0;
	for i := 1 to length(s) - 1
	do begin
		if s[i] in digithg
		then result := result * 16 + ord(s[i]) - 55
		else begin
			if s[i] in digithk
			then result := result * 16 + ord(s[i]) - 55 - 32
			else begin
				if s[i] in digitd
				then result := result * 16 + ord(s[i]) - 48
				else begin
					errlst('in Konstante: ' + s, 'D');
					result := 1;
					break;
				end;
			end;
		end;
	end;
end;

function Tcalc.numdec(s: string): int64;
var
	i:			integer;
begin
	result := 0;
	for i := 1 to length(s)
	do begin
		if s[i] in digitd
		then result := result * 10 + ord(s[i]) - 48
		else begin
			errlst('in Konstante: ' + s, 'D');
			result := 1;
			break;
		end;
	end;
end;

function Tcalc.numoct(s: string): int64;
var
	i:			integer;
begin
	result := 0;
	for i := 1 to length(s) - 1
	do begin
		if s[i] in digito
		then result := result * 8 + ord(s[i]) - 48
		else begin
			errlst('in Konstante: ' + s, 'D');;
			result := 1;
			break;
		end;
	end;
end;

function Tcalc.numbin(s: string): int64;
var
	i:			integer;
begin
	result := 0;
	for i := 1 to length(s) - 1
	do begin
		if s[i] in digitb
		then result := result * 2 + ord(s[i]) - 48
		else begin
			errlst('in Konstante: ' + s, 'D');
			result := 1;
			break;
		end;
	end;
end;

function Tcalc.ber(w: int64; o: char): int64;
var
	nw:		int64;
	no:		char;
	nn:		string[32];
	fk:		integer;
begin
	nw := 0;
	nn := '';
	fk := 1;
	if wnum[wind] = '-'
	then begin
		fk := -1;
		inc(wind);
	end;
	while (wind < length(wnum))
	and not (wnum[wind] in opera)
	do begin
		if wnum[wind] = ''''
		then begin
			nn := nn + wnum[wind];
			inc(wind);
			while (wind < length(wnum))
			and not (wnum[wind] = '''')
			do begin
				nn := nn + wnum[wind];
				inc(wind);
			end;
		end;
		nn := nn + wnum[wind];
		inc(wind);
	end;
	if nn[1] in digitd
	then begin
		case nn[length(nn)] of
		'h', 'H':	nw := numhex(nn) * fk;
		'o', 'O':	nw := numoct(nn) * fk;
		'b', 'B':	nw := numbin(nn) * fk;
		else			nw := numdec(nn) * fk;
		end;
	end
	else begin
		if nn > ''
		then begin
			if nn[1] = ''''
			then nw := ord(nn[2])
			else nw := getname(nn).adr * fk;
		end;
	end;
	no := wnum[wind];
	inc(wind);
	case no of
	' ': 	result := act(o, w, nw);
	'.':
		begin
			if nw > 127
			then result := ber(act(o, w, nw), '+')
			else result := ber(act(o, w, (nw - 32) * 8), '+');
		end;
	')':
		begin
			dec(klev);
			result := act(o, w, nw);
		end;
	'(':
		begin
			inc(klev);
			nw := ber(0, '#');
			no := wnum[wind];
			inc(wind);
			case no of
			' ':	result := act(o, w, nw);
			'.':  result := ber(act(o, w, nw), '+');
			')':
				begin
					dec(klev);
					result := act(o, w, nw);
				end;
			else
				begin
					if lev(o) <= lev(no)
					then result := ber(act(o, w, nw), no)
					else result := act(o, w, ber(nw, no));
				end;
			end;
		end;
	else
		begin
			if lev(o) <= lev(no)
			then result := ber(act(o, w, nw), no)
			else result := act(o, w, ber(nw, no));
		end;
	end;
end;

function Tcalc.adr(Input: string): integer;//tnametab;
begin
	wnum := Input + ' ';
//	if assigned(memo)
//	then begin
//		memo.Clear;
//		memo.Lines.Add(wnum);
//	end;
	wind := 1;
	klev := 0;
	result := ber(0, '#');
	if klev <> 0
	then errlst('Klammern falsch', 'D');
//	result := tag;
end;

procedure Tcalc.DataModuleCreate(Sender: TObject);
begin
	digithg :=
		['A', 'B', 'C', 'D', 'E', 'F'];
	digithk :=
		['a', 'b', 'c', 'd', 'e', 'f'];
	digitd :=
		['0', '1', '2', '3', '4',
		'5', '6', '7', '8', '9'];
	digito :=
		['0', '1', '2', '3', '4', '5', '6', '7'];
	digitb :=
		['0', '1'];
	opera :=
		[' ', '<', '>', '+', '-', '.',
		'*', '/', '(', ')', '|', '&', '^'];
end;

end.

