unit disa;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs,
	IniFiles;

type
{$i twork.pic}

	Tdisadm =
	class(TDataModule)
		procedure 	DataModuleCreate(Sender: TObject);
		procedure 	DataModuleDestroy(Sender: TObject);
	private		{ Private-Deklarationen }
		procedure	code;
	public		{ Public-Deklarationen }
		procedure	disass(dat: string);
	end;

var
	disadm: 		Tdisadm;
	wrk:			pTwork;
	adr:			word;
	lng:			byte;

	adrt:			array [0..16383] of word;
	adre,
	adra:			word;
	prol,
	orgl:			integer;
	tmp,
	dsd:			tstringlist;
	nadr:			boolean;
	o0,
	o1,
	o2:			byte;

const
	fl = '%4.4x %4.4x %s';
	fc = '%4.4x ;%s';
	fo = '%4.4x1%-8s%s';
	sdefext = '.d51';
	cdefext = '.dsd';
	inia  = 'Allgemein';
	inis  = 'Startoptionen';
	inio  = 'Optionen d51';

implementation

uses assoptu, assu;

{$R *.DFM}

procedure addadr(adr: word);
begin
	if adr > prol
	then exit;			// fehler !
	adrt[adre] := adr;
	inc(adre);
	if adre > high(adrt)
	then adre := 0;
end;

procedure veradr();
begin
	if adre = adra
	then begin
		adr := 0;
		exit;
	end;
	adr := adrt[adra];
	inc(adra);
end;

{$i disacode.pic}

procedure Tdisadm.DataModuleCreate(Sender: TObject);
begin
	tmp := tstringlist.create;
	dsd := tstringlist.create;
end;

procedure Tdisadm.DataModuleDestroy(Sender: TObject);
begin
	tmp.free;
	dsd.Free;
end;

function Sort(
			List: TStringList;
			Index1, Index2: Integer): Integer;
begin
	result := 0;
	if list[index1] < list[index2]
	then result := -1;
	if list[index1] > list[index2]
	then result := 1;
end;

procedure Tdisadm.disass(dat: string);
var
	f:			file;
	s:			string;
	i,
	j,
	l,
	a:			integer;
begin
	if not fileexists(dat)
	then exit;
	for i := 0 to high(adrt)
	do adrt[i] := 0;
	adra := 0;
	adre := 0;
	for i := 0 to high(wrk.line)
	do wrk.line[i] := 0;
	tmp.Clear;
	tmp.Sorted := false;

	assignfile(f, dat);
	reset(f, 1);
	blockread(f, wrk.prog, high(wrk.prog), prol);
	closefile(f);

	if fileexists(changefileext(dat, cdefext))
	then s := changefileext(dat, cdefext)
	else s := extractfilepath(paramstr(0))	+ wrk.proz + cdefext;

	dsd.LoadFromFile(s);
	for i := 0 to dsd.Count - 1
	do begin
		if uppercase(copy(dsd.Strings[i], 1, 1)) = 'L'
		then begin
			addadr(strtoint('$' + copy(dsd.Strings[i], 3, 4)));
			tmp.Add(copy(dsd.Strings[i], 3, 4) +
						',' + copy(dsd.Strings[i], 9, 50));
		end;
		if uppercase(copy(dsd.Strings[i], 1, 1)) = 'C'
		then begin
			a := strtoint('$' + copy(dsd.Strings[i], 3, 4));
			s := trim(copy(dsd.Strings[i], 8, 7));
			l := strtoint(copy(s, 1, pos(',', s) - 1));
			j := strtoint(copy(s, pos(',', s) + 1, 5));
			for j := j downto 1
			do begin
				addadr(a);
				inc(a, l);
			end;
		end;
	end;
	tmp.add('0000*        org     0');
	veradr;
	code;
	veradr;
	while adr > 0
	do begin
		code;
		if adr = 0
		then veradr;
	end;
	s := '';
	for i := 0 to prol - 1
	do begin
		if wrk.line[i] = 0
		then begin
			if wrk.prog[i] = 255
			then inc(orgl)
			else begin
				if orgl > 0
				then begin
					tmp.add(inttohex(i, 4)
								+ '*        org     $+'
								+ inttostr(orgl));
					orgl := 0;
				end;
				if (wrk.prog[i] >= ord(' '))
				and (wrk.prog[i] < ord('~'))
				then begin
					s := s + char(wrk.prog[i]);
				end
				else begin
					if s > ''
					then begin
						tmp.add(format('%4.4x);        db      ''%s''', [i, s]));
						s := '';
					end;
				end;
				tmp.add(format(
						'%4.4x.        db      0%2.2xh ; %4.4x %3d',
						[i, wrk.prog[i], i, wrk.prog[i]]));
			end;
		end
		else begin
			if s > ''
			then begin
				tmp.add(format('%4.4x);       db      ''%s''', [i, s]));
				s := '';
			end;
			if orgl > 0
			then begin
				tmp.add(inttohex(i, 4)
							+ '*        org     $+'
							+ inttostr(orgl));
				orgl := 0;
			end;
		end;
	end;
	tmp.CustomSort(sort);
	j := 0;
	for i := tmp.Count - 1 downto 1
	do begin
		if ((copy(tmp[i], 5, 1) = '-')
			or (copy(tmp[i], 5, 1) = '('))
		and (copy(tmp[i], 1, 10) = copy(tmp[i - 1], 1, 10))
		then begin
			s := tmp[i];
			if j < 7
			then begin
				tmp[i - 1] := tmp[i - 1]
							+ copy(s, pos(';', s) + 1, 255);
				tmp.Delete(i);
				inc(j);
			end
			else begin
				tmp[i] := copy('                     ',
									1, pos(';', s) - 1)
							+ copy(s, pos(';', s), 255);
				j := 0;
			end;
		end
		else begin
			j := 0;
			tmp[i] := copy(tmp[i], 6, 255);
		end;
	end;
	tmp[0] := copy(tmp[0], 6, 255);
	tmp.SaveToFile(changefileext(dat, '.d51'));
	dsd.SaveToFile(changefileext(dat, '.dsd'));
end;

end.
