unit fpu;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls;

type
	Tfp =
	class(TForm)
		gbfp: TGroupBox;
		Label9: 		TLabel;
		signlab: 	TLabel;
		Label12: 	TLabel;
		fps: 			TButton;
		fpPL: 		TCheckBox;
		fpL1: 		TCheckBox;
		fpPV: 		TCheckBox;
		fpL2: 		TCheckBox;
    porta: TComboBox;
		fpl: 			TButton;
		fpPS: 		TCheckBox;
    	fpc: 			TButton;
    portn: TComboBox;
		procedure 	FormCreate(Sender: TObject);
		procedure 	FormActivate(Sender: TObject);
		procedure 	fpClick(Sender: TObject);
		procedure 	fpsClick(Sender: TObject);
		procedure 	fplClick(Sender: TObject);
		procedure 	FormDeactivate(Sender: TObject);
	private		{ Private-Deklarationen}
		Sign:			dword;
		Adr:			Integer;
		Mask:			byte;
		Fehler:		string;
		procedure 	WrByte(Wo: byte; Wert: byte);
		procedure 	Puls(Wie: byte; Was: byte);
		function  	RdByte(Wo: byte): byte;
		procedure 	StartUp;
		function 	TestVerb: boolean;
		function 	Siglesen: boolean;
		function 	Loeschen: boolean;
		function 	Brennen: boolean;
		function 	Lesen: boolean;
		function 	Vergleich: boolean;
		function 	Lockbit1: boolean;
		function 	Lockbit2: boolean;
		function 	SonderFunkt(Was: byte; Del: Integer): boolean;
	public		{ Public-Deklarationen}
		Write:		boolean;
	end;

var
	fp: Tfp;

implementation

uses assu;

{$R *.DFM}

const
	THEDLL='PORT.DLL';
	ProgP		= $FD;	// Programierpuls (Low)
	AdInc   	= $04;	// Adresse Incrementieren
	Takt    	= $80;	// Takt fr Speicher
	RST12   	= $03;	// RST auf 12 Volt
	RST5V   	= $02;	// RST auf  5 Volt
	VOFF    	= $01;	// RST auf LOW
	Mask    	= $80;	// Maske (zum reinUNDen d. Bits )
	WrDat   	= $08;	// SendeDaten (sende Bit)
	STROBE	= $40;	// Register Daten rein/raus
	BUSY    	= $20;	// PE Bit
	Test    	= $60;	// Teste Interface
	ProzL	  	= $03;	// Lese Daten aus Prozessor
	RegWr	 	= $23;	// Daten ins Register stellen
	ProzS   	= $2B;	// Daten in Prozessor schreiben
	SigL    	= $02;	// SignaturByte auslesen
	Eras    	= $12;	// Speicher lschen
	Lock1   	= $33;	// Lock Bit 1 setzen
	Lock2   	= $32;   // Lock Bit 2 setzen
	inin		= 'FlashProg';
var
	erg:		boolean;

function 	OPENCOM(S:PCHAR):Integer;	stdcall; external THEDLL;
function 	CLOSECOM:Integer;        	stdcall; external THEDLL;
procedure 	OUTPORT(Adr:Word; Wo:byte);stdcall; external THEDLL;
function 	INPORT(Adr:Word): byte;    stdcall; external THEDLL;
procedure 	DELAY(S:integer);          stdcall; external THEDLL;
procedure 	DELAYUS(S:integer);        stdcall; external THEDLL;
procedure 	SENDBYTE(d:WORD)           stdcall; external THEDLL;

procedure Tfp.FormCreate(Sender: TObject);
begin
	autosize := true;
	with assf
	do begin
		assf.RIniForm(inin, Self);
		porta.ItemIndex := wrk.inif.readinteger(inin, 'PortFPa', 0);
		portn.ItemIndex := wrk.inif.readinteger(inin, 'PortFPn', 0);
		fpPL.Checked := wrk.inif.readbool(inin, 'ProzLoesch', true);
		fpPS.Checked := wrk.inif.readbool(inin, 'ProgSchreiben', true);
		fpPV.Checked := wrk.inif.readbool(inin, 'ProzVergl', true);
		fpL1.Checked := wrk.inif.readbool(inin, 'Lockbit1', true);
		fpL2.Checked := wrk.inif.readbool(inin, 'Lockbit2', true);
		fpL.Enabled := wrk.inif.readbool(inin, 'Lesen', true);
		fpS.Enabled := wrk.inif.readbool(inin, 'Schreiben', false);
	end;
end;

procedure Tfp.FormDeactivate(Sender: TObject);
begin
	assf.WIniForm(inin, Self);
	wrk.inif.writeinteger(inin, 'PortFPa', porta.ItemIndex);
	wrk.inif.writeinteger(inin, 'PortFPn', portn.ItemIndex);
	wrk.inif.writebool(inin, 'ProzLoesch', fpPL.Checked);
	wrk.inif.writebool(inin, 'ProgSchreiben', fpPS.Checked);
	wrk.inif.writebool(inin, 'ProzVergl', fpPV.Checked);
	wrk.inif.writebool(inin, 'Lockbit1', fpL1.Checked);
	wrk.inif.writebool(inin, 'Lockbit2', fpL2.Checked);
	wrk.inif.writebool(inin, 'Lesen', fpL.Enabled);
	wrk.inif.writebool(inin, 'Schreiben', fpS.Enabled);
end;

procedure Tfp.FormActivate(Sender: TObject);
begin
	if not wrk.bval
	then begin
		fpPL.enabled := false;
		fpPS.Enabled := false;
		fpPV.Enabled := false;
		fpL1.Enabled := false;
		fpL2.Enabled := false;
		fpl.Enabled := true;
		fps.Enabled := false;
	end
	else begin
		fpPL.enabled := true;
		fpPS.Enabled := true;
		fpPV.Enabled := true;
		fpL1.Enabled := true;
		fpL2.Enabled := true;
		fps.Enabled := true;
		fpl.Enabled := false;
	end;
end;

procedure Tfp.fpClick(Sender: TObject);
begin
	with sender as TCheckBox
	do begin
		if Checked
		then begin
			fpl.Enabled := false;
			fps.Enabled := true;
		end;
	end;
end;

procedure Tfp.Puls(Wie: byte; Was: byte);
begin
  OUTPORT(Adr,Wie or Was);                // Strobe / AdressInc Pulsen
  OUTPORT(Adr,Wie);
end;

function Tfp.RdByte(Wo: byte): byte;
var
	zahl: 	integer;
	was:		byte;
begin
	was := 0;
	OUTPORT(Adr,Wo);								// Byte ins Register lesen
	for zahl := 1 to 8 do
	begin
		was := was shl 1;							// Bits sammeln
		OUTPORT(Adr,Wo );							// Takten
		if NOT INPORT(Adr+1)
		and Mask = Mask
		then was := was or $01;					// Bits holen
		OUTPORT(Adr, Wo or Takt);				// Takt rcksetzen
	end;
	RdByte := was;
end;

procedure Tfp.WrByte(Wo: byte; Wert: byte);
var
	zahl: 	integer;
	was,
	wma: 		byte;
begin
	was := Wert;
	for zahl := 1 to 8 do
	begin
		wma := 0;
		if was and Mask = Mask
		then wma := WrDat;
		OUTPORT(Adr,Wo or wma);
		OUTPORT(Adr,Wo or wma or Takt);		// ins Register takten
		OUTPORT(Adr,Wo or wma);
		was := was shl 1;
	end;
	OUTPORT(Adr,Wo or STROBE); 				// Byte in Processor
end;

procedure Tfp.StartUp;
begin
	OUTPORT(Adr+2,VOFF);							// RST LOW
	OUTPORT(Adr,$0);								// AdInc LOW
	DELAY (15);
	OUTPORT(Adr+2,RST5V);						// RST  High
	OUTPORT(Adr,$02);								// PROG High
	OUTPORT(Adr+2,VOFF);
	OUTPORT(Adr,$0);
end;

function Tfp.TestVerb;
var
	b:			boolean;
begin
	StartUp;
	b := False;
	WrByte(Test,$A5);
	if RdByte(Test)= $A5 then
	begin
		WrByte(Test,$5A);
		if RdByte(Test) = $5A then
		b := True;
	end;
	if not b
	then Fehler := 'Fehler! Keine Verbindung. ';
	TestVerb := b;
end;

function Tfp.SonderFunkt(Was: byte; Del: Integer): boolean;
begin
	WrByte(RegWr,$FF);        		// wichtig sonst=Byte1 falsch
	DELAY(5);				       	// zur Datenberuhigung
	OUTPORT(Adr+2,RST12);       	// 12 V setzen
	OUTPORT(Adr,Was);
	OUTPORT(Adr,Was and ProgP);	// ProgramierImpuls
	DELAY(Del);
	OUTPORT(Adr,Was);           	// ProgramierImpuls
	OUTPORT(Adr,$0 );
	OUTPORT(Adr+2,VOFF);        	// RST  High
	SonderFunkt := true;
end;

function Tfp.Siglesen;
var
	i:			Integer;
begin
	OUTPORT(Adr+2, RST5V);         	// RST  High
	sign := 0;
	for i := 0 to 2
	do begin
		Puls(SigL, STROBE);
		Sign := Sign + RdByte(SigL);	// Daten vom Processor lesen
		Sign := sign shl 8;
		Puls(SigL, AdInc);
	end;
	OUTPORT(Adr,$0 );
	OUTPORT(Adr+2, VOFF);				// RST  High
	Siglesen := true;
end;

function Tfp.loeschen;
begin
	loeschen := SonderFunkt(Eras, 15);
end;

function Tfp.Brennen;
var
	i,
	z:			Integer;
begin
	StartUp; 								// Adresse rcksetzen
	OUTPORT(Adr+2,RST12);				// 12 V setzen
	for i := wrk.tabl to wrk.tabh do
	begin
		z := 1;
		if wrk.brtr[i] and byteu > 0
		then begin
			WrByte(RegWr,wrk.prog[i]);		// Daten ins Register setzen
			DELAY(3);				       	// zur Datenberuhigung
			OUTPORT(Adr,ProzS and ProgP);	// ProgramierImpuls
			DELAYUS(2);
			OUTPORT(Adr,ProzS);				// ProgramierImpuls rcksetzen
			DELAYUS(1);
			repeat
				inc(z);
			until (INPORT(Adr+1)
				and BUSY = 0)
				or (z > 50000); 				// Busy abwarten
		end;
		DELAY(1);
		Puls(ProzS,AdInc);
	end;
	OUTPORT(Adr+2,VOFF);					// 0 V setzen
	OUTPORT(Adr,$0);
	Brennen := true;
end;

function Tfp.Vergleich;
var
	i: 		Integer;
begin                            // Proz.Inhalt vergleichen
	i := 0;
	Vergleich := true;
	StartUp;
	OUTPORT(Adr+2,RST5V);			// RST  High
	while i < wrk.roms
	do begin
		Puls(ProzL,STROBE);
		if wrk.prog[i] = RdByte(ProzL)
		then begin        			// Daten vom Processor lesen
			inc(i);
			Puls(ProzL,AdInc);
		end
		else begin
			fehler := 'Fehler! Die Daten auf Adresse: '
					+ IntToHex(i,4)
					+ ' sind nicht gleich! ';
			Vergleich := false;
			break;
		end;
	end;
	OUTPORT(Adr+2,VOFF);				// RST  Low
end;

function Tfp.Lesen;
var
	i: 		Integer;
begin
	OUTPORT(Adr+2,RST5V);			// RST  High
	i := 0;
	while  i < wrk.roms
	do begin
		Puls(ProzL,STROBE);
		wrk.prog[i] := RdByte(ProzL);	// Daten vom Processor lesen
		wrk.brtr[i] := byteu;
		Puls(ProzL,AdInc);
		inc(i);
		if i mod 16 = 0
		then application.processmessages;
	end;
	OUTPORT(Adr,$0 );
	OUTPORT(Adr+2,VOFF);
	Lesen := true;
end;

function Tfp.Lockbit1;
begin
	Lockbit1 := SonderFunkt(Lock1, 2);
end;

function Tfp.Lockbit2;
begin
	Lockbit2 := SonderFunkt(Lock2, 2);
end;

procedure Tfp.fpsClick(Sender: TObject);
var
	rc:  		integer;
begin
//	case porta.itemIndex	of
//	0: Adr := $378;
//	1: adr := $278;
//	2: adr := $3BC;
//	end;
	rc := OPENCOM(PChar(portn.text));
	if rc = 0
	then begin
		erg := TestVerb;
		if erg
		then begin
			fp.Color := clgray;
			erg := Siglesen;
			if erg
			then signlab.Caption := format('%8.8x', [sign]);
			if erg and fpPL.Checked
			then begin
				erg := Loeschen
			end;
			if erg and fpPS.Checked
			then begin
				erg := Brennen
			end;
			if erg and fpPV.Checked
			then begin
				erg := Vergleich
			end;
			if erg and fpL1.Checked
			then begin
				erg := Lockbit1;
			end;
			if fpL2.Checked
			then begin
				erg := Lockbit2;
			end;
		end;
		if not erg
		then begin
			fp.Color := clred;
			messagedlg(Fehler, mtError, [mbOK],0);
		end;
		rc := CLOSECOM;
		if rc > 0
		then begin
			fp.Color := clred;
			messagedlg(format('Fehler bei CLOSE %d', [rc]),
						mtError, [mbOK],0);
		end;
	end
	else begin
		fp.Color := clred;
		messagedlg(format('Fehler bei OPEN: %d', [rc]),
					mtError, [mbOK],0);
	end;
	fp.Color := clBtnFace;
end;

procedure Tfp.fplClick(Sender: TObject);
begin
	erg := TestVerb;
	if erg
	then begin
		fp.Color := clgray;
		erg := Siglesen;
		if erg
		then begin
			signlab.Caption := format('%8.8x', [sign]);
			erg := Lesen;
		end;
	end
	else begin
		fp.Color := clred;
		messagedlg(Fehler, mtError, [mbOK],0);
	end;
	fp.Color := clBtnFace;
end;

end.
