unit gpu;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls;

type
	Tgp =
	class(TForm)
	 	gbgp: 		TGroupBox;
		gps: 			TButton;
		gpPL: 		TCheckBox;
		gpL1: 		TCheckBox;
		gpL2: 		TCheckBox;
		gpPS: 		TCheckBox;
		galeps: 		TButton;
		od: 			TOpenDialog;
    	gpv: 			TButton;
    gpr: TButton;
		procedure 	FormActivate(Sender: TObject);
		procedure 	gpvClick(Sender: TObject);
		procedure 	gpsClick(Sender: TObject);
		procedure 	FormCreate(Sender: TObject);
		procedure 	FormDestroy(Sender: TObject);
    	procedure 	galepsClick(Sender: TObject);
		procedure 	gprClick(Sender: TObject);
	private		{ Private-Deklarationen}
		function 	StartProc(cmd: string): boolean;
	public		{ Public-Deklarationen}
		typ:			string;
		her:			string;
		dev:			string;
		pro:			string;
	end;

var
	gp: 		Tgp;
	ts:		TStringList;
	galpro:	string;

implementation

uses assu, binhexu;

{$R *.DFM}

const
	bez		= 'Galep3Prog';

function Tgp.StartProc(cmd: string): boolean;
var
	si:		TStartupInfo;
	pi:		TProcessinformation;
	c:			array [0..255] of char;
begin
	strpcopy(c, cmd);
	fillchar(si, sizeof(si), 0);
	si.cb := sizeof(si);
	si.dwflags := STARTF_USESHOWWINDOW;
	si.wshowwindow := SW_SHOWMINNOACTIVE;
	si.lptitle := nil; 			// dateiname
	Result := CreateProcess(
						nil,			// lpApplicationName: PChar;
						c,				// lpCommandLine: PChar;
						nil,			// lpProcessAttributes,
						nil,			// lpThreadAttributes: PSecurityAttributes;
						false,		// bInheritHandles: BOOL;
						0,		 		// dwCreationFlags: DWORD;
						nil,			// lpEnvironment: Pointer;
						nil,			// lpCurrentDirectory: PChar;
						si,			// const lpStartupInfo: TStartupInfo;
						pi);			// var lpProcessInformation: TProcessInformation)
end;

procedure Tgp.FormActivate(Sender: TObject);
begin
	if not wrk.bval
	then begin
		gpPL.enabled := false;
		gpPS.Enabled := false;
		gpL1.Enabled := false;
		gpL2.Enabled := false;
		gpr.Enabled := true;
		gpv.Enabled := false;
		gps.Enabled := false;
	end
	else begin
		gpPL.enabled := true;
		gpPS.Enabled := true;
		gpL1.Enabled := true;
		gpL2.Enabled := true;
		gpr.Enabled := false;
		gps.Enabled := true;
		gpv.Enabled := true;
	end;
end;

procedure Tgp.gprClick(Sender: TObject);
begin
	deletefile('tmp.bin');
	ts.Clear ;
	ts.Add ('{');
	ts.Add ('  SelectDevice ("' + typ + '.' + her + '.' + dev + '");');
	ts.Add ('  Message ("Galep III", "' + dev +' einsetzen");');
	ts.Add ('  AddAutoOk();');
	ts.Add ('  AddAutoOk();');
	ts.Add ('  Read();');
	ts.Add ('  SaveFile ("tmp.bin");');
	ts.Add ('  Message ("Galep III", "' + dev + ' entfernen");');
	ts.Add ('  Exit();');
	ts.Add ('}');
	ts.SaveToFile ('tmp.gsl');
	startproc(galpro + ' -itmp.gsl -ltmp.log');
end;

procedure Tgp.gpvClick(Sender: TObject);
begin
	bh.bin('tmp.bin');
	ts.Clear ;
	ts.Add ('{');
	ts.Add ('  SelectDevice ("' + typ + '.' + her + '.' + dev + '");');
	ts.Add ('  Message ("Galep III", "' + dev +' einsetzen");');
	ts.Add ('  LoadFile ("tmp.bin");');
	ts.Add ('  AddAutoOk();');
	ts.Add ('  Verify();');
	ts.Add ('  Message ("Galep III", "' + dev + ' entfernen");');
	ts.Add ('  Exit();');
	ts.Add ('}');
	ts.SaveToFile ('tmp.gsl');
	startproc(galpro + ' -itmp.gsl -ltmp.log');
end;

procedure Tgp.gpsClick(Sender: TObject);
begin
	bh.bin('tmp.bin');
	ts.Clear ;
	ts.Add ('{');
	ts.Add ('  SelectDevice ("' + typ + '.' + her + '.' + dev + '");');
	ts.Add ('  Message ("Galep III", "' + dev +' einsetzen");');
	ts.Add ('  LoadFile ("tmp.bin");');
	if gpPL.Checked
	then begin
		ts.Add ('  AddAutoOk();');
		ts.Add ('  AddAutoOk();');
		ts.Add ('  Erase ();');
	end;
	if gpL1.Checked
	then ts.Add ('  SetOption (LOCKBIT1);');
	if gpL1.Checked
	then ts.Add ('  SetOption (LOCKBIT2);');
	ts.Add ('  AddAutoOk();');
	ts.Add ('  AddAutoOk();');
	ts.Add ('  Program ();');
	ts.Add ('  Message ("Galep III", "' + dev + ' entfernen");');
	ts.Add ('  Exit();');
	ts.Add ('}');
	ts.SaveToFile ('tmp.gsl');
	startproc(galpro + ' -itmp.gsl -ltmp.log');
end;

procedure Tgp.FormCreate(Sender: TObject);
begin
	autosize := true;
	ts := TStringList.Create ;
	with assf
	do begin
		assf.RIniForm(bez, Self);
		galpro := wrk.inif.readstring(bez, 'Programm', 'c:\Galep3\Galep3.exe');
		gpPL.Checked := wrk.inif.readbool(bez, 'ProzLoesch', true);
		gpPS.Checked := wrk.inif.readbool(bez, 'ProgSchreiben', true);
		gpL1.Checked := wrk.inif.readbool(bez, 'Lockbit1', true);
		gpL2.Checked := wrk.inif.readbool(bez, 'Lockbit2', true);
		gpv.Enabled := wrk.inif.readbool(bez, 'Vergleichen', true);
		gpS.Enabled := wrk.inif.readbool(bez, 'Schreiben', false);
	end;
end;

procedure Tgp.FormDestroy(Sender: TObject);
begin
	ts.Free ;
	if not Assigned(wrk.inif)
	then exit;
	with assf
	do begin
		assf.WIniForm(bez, Self);
		wrk.inif.writestring(bez, 'Programm', galpro);
		wrk.inif.writebool(bez, 'ProzLoesch', gpPL.Checked);
		wrk.inif.writebool(bez, 'ProgSchreiben', gpPS.Checked);
		wrk.inif.writebool(bez, 'Lockbit1', gpL1.Checked);
		wrk.inif.writebool(bez, 'Lockbit2', gpL2.Checked);
		wrk.inif.writebool(bez, 'Vergleichen', gpv.Enabled);
		wrk.inif.writebool(bez, 'Schreiben', gpS.Enabled);
	end;
end;

procedure Tgp.galepsClick(Sender: TObject);
begin
	if od.Execute
	then begin
		galpro := od.FileName;
	end;
end;

end.
