unit timeru;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, Dialogs, math;

type
	Ttim =
	class(TDataModule)
	private		{ Private-Deklarationen}
		_P3_4_old:  boolean;
		_P3_5_old:  boolean;
//		t0,
//		t1:			word;
		tl0,
		tl1,
		tl2,
		th0,
		th1,
		th2:			byte;
		m0,         // timer mode 0-3, 4-5= PWM
		m1,         // timer mode 0-3, 4-5= PWM
		m2,         // timer mode 0-3, 4-5= PWM
		ms,
		cl,
		p0,			// prescaler
		p1,
		p2,
		pm0,        // prescaler maske;
		pm1,
		pm2,
		o0,			// zwischespeicher fr PWM
		o1,
		o2:			byte;
		v0,         // outpin valid
		v1,
		v2:			boolean;
		procedure	tickT0(clok:	byte);
		procedure	tickT1(clok:	byte);
		procedure	serial();
	public		{ Public-Deklarationen}
		iclock:		byte;
		procedure 	Tick(clk: byte);
	end;

var
	tim: 		Ttim;

implementation

uses simu;

{$R *.DFM}

procedure Ttim.serial();
begin
	if (wrk.scow > 0)
	then begin
		dec(wrk.scow);
		if wrk.scow = 0
		then begin
			wrk.bitm(_TI, true);
		end;
	end;
end;

procedure Ttim.Tick(clk: byte);
var
	clk2,
	clk3:		byte;
begin
//	tim.Tag := 0;
	// cyles berechnen
	clk2 := clk;
	if wrk.clkt[0] > 10				// clocks NOP
	then clk := clk div 12;
	m0 := wrk.sfrs[_TMOD] and $03;
	m1 := (wrk.sfrs[_TMOD] and $30) shr 4;
	ms := wrk.sfrs[_SCON] and $C0;
	th0 := wrk.sfrs[_TH0];
	tl0 := wrk.sfrs[_TL0];
	th1 := wrk.sfrs[_TH1];
	tl1 := wrk.sfrs[_TL1];
	v0 := not (((wrk.sfrs[_P3M0] and $10) > 0)
		and  ((wrk.sfrs[_P3M1] and $10) = 0));
	v1 := not (((wrk.sfrs[_P3M0] and $20) > 0)
		and  ((wrk.sfrs[_P3M1] and $20) = 0));
	p0 := 4;
	pm0 := $1f;
	p1 := 4;
	pm1 := $1f;
	if wrk.sfrd[_TCONB]
	then begin
		if (wrk.sfrs[_TCONB] and $80) > 0
		then m1 := m1 + 4;
		if (wrk.sfrs[_TCONB] and $40) > 0
		then m0 := m0 + 4;
		p0 := wrk.sfrs[_TCONB] and $07;
		p1 := (wrk.sfrs[_TCONB] and $31) shr 3;
		pm0 := trunc(intpower(2, p0 + 1)) - 1;
		pm1 := trunc(intpower(2, p1 + 1)) - 1;
	end;
	// wartezeit
	if (wrk.scww > 0)
	then begin
		clk3 := clk;
		while (clk3 > 0) and (wrk.scww > 0)
		do begin
			dec(wrk.scww);
			if wrk.scww = 0
			then begin
				simf.startserin;
			end;
			dec(clk3);
		end;
	end
	else begin
		simf.startserin;
	end;

	// serial ohne timer
	case ms of
	$00:
		begin
			while clk2 > 0
			do begin
				if cl = 0
				then begin
					serial;
					cl := 12;
				end;
				dec(cl);
				dec(clk2);
			end;
		end;
	$80:
		begin
			while clk2 > 0
			do begin
				if cl = 0
				then begin
					serial;
					cl := 32;
				end;
				if (wrk.sfrs[_PCON] and $80) = 0
				then cl := cl * 2;
				dec(cl);
				dec(clk2);
			end;
		end;
	end;

	// timer 0
	if wrk.bitg(_TR0)	 									// TR0
	and ((wrk.sfrs[_TMOD] and $08 = 0)				// Gate0 = 0
		or wrk.bitg(_P3_2))	         				// int0
	then begin
		tickT0(clk);
	end;
	// timer 1
	iclock := clk;
	if m0 = 3
	then begin
		while iclock > 0
		do begin
			if wrk.bitg(_TR1)	 			  				// TR1
			then begin
				inc(th0);
				wrk.sfrs[_TH0] := th0;
				if th0 = 0
				then begin
					wrk.bitm(_TF1, true);  	 			// interrupt
//				tim.tag := _TF1;
				end;
			end;
			dec(iclock);
		end;
		if m1 <> 3
		then tickT1(clk);
	end
	else begin
		if m1 <> 3
		then begin
			if wrk.bitg(_TR1)								// TR1
			and ((wrk.sfrs[_TMOD] and $80 = 0)		// Gate1 = 0
				or wrk.bitg(_P3_3))          			// int1
			then tickT1(clk);
		end;
	end;
end;

procedure Ttim.tickT0(clok:	byte); 					// timer 0
begin
	iclock := clok;
	if wrk.sfrs[_TMOD] and $04 > 0
	then begin                         				// counter
		if _P3_4_old and not wrk.bitg(_P3_4)
		then begin
			iclock := 1;
		end
		else begin
			_P3_4_old := wrk.bitg(_P3_4);
			exit;
		end;
	end;
	_P3_4_old := wrk.bitg(_P3_4);
	while iclock > 0
	do begin
		case m0 of
		0:				// 13 bit zhler, bei atlp 9-16 bit
			begin
				inc(tl0);
				if (tl0 and pm0) = 0
				then begin
					inc(th0);
					if th0 = 0
					then begin
						wrk.bitm(_TF0, true);			// interrupt
//						tim.tag := _TF0;
					end;
				end;
			end;
		1:				// 16 bit zhler, bei atlp... reload
			begin
				inc(tl0);
				if tl0 = 0
				then begin
					inc(th0);
					if th0 = 0
					then begin
						if wrk.sfrd[_RH0]					// reload ???
						then begin
							th0 := wrk.sfrs[_RH0];
							tl0 := wrk.sfrs[_RL0];
						end;
						wrk.bitm(_TF0, true);			// interrupt
//						tim.tag := _TF0;
					end;
				end;
			end;
		2:				// 8 bit auto reload
			begin
				inc(tl0);
				if tl0 = 0
				then begin
					tl0 := th0;								// reload;
					wrk.bitm(_TF0, true);				// interrupt
//					tim.tag := _TF0;
				end;
			end;
		3:				// 2x 8 bit low
			begin
				inc(tl0);
				if tl0 = 0
				then begin
					wrk.bitm(_TF0, true);				// interrupt
//					tim.tag := _TF0;
				end;
			end;
		4:				// n + 8 bit zhler PWM
			begin
				inc(tl0);
				if tl0 and pm0 = 0
				then begin
					tl0 := 0;
					inc(th0);
					if th0 = 0
					then begin
						o0 := wrk.sfrs[_RH0];
						if (o0 > 0)
						and v0
						then wrk.bitm(_P3_4, true);
					end;
					if th0 = o0
					then begin
						if v0
						then wrk.bitm(_P3_4, false);
					end;
				end;
			end;
		5:					// 8 + 8 bit zhler PWM
			begin
				inc(tl0);
				if tl0 = 0
				then begin
					tl0 := wrk.sfrs[_RL0];
					inc(th0);
					if th0 = 0
					then begin
						o0 := wrk.sfrs[_RH0];
						if (o0 > 0)
						and v0
						then wrk.bitm(_P3_4, true);
					end;
					if th0 = o0
					then begin
						if v0
						then wrk.bitm(_P3_4, false);
					end;
				end;
			end;
		end;
		dec(iclock);
	end;
	wrk.ssfr(_TL0, tl0);
	wrk.ssfr(_TH0, th0);
end;

procedure Ttim.tickT1(clok:	byte);
begin
	iclock := clok;
	_P3_5_old := wrk.bitg(_P3_5);
	if wrk.sfrs[_TMOD] and $40 > 0
	then begin                         	// counter
		if _P3_5_old and not wrk.bitg(_P3_5)
		then begin
//			clok := 1;
		end
		else begin
			_P3_5_old := wrk.bitg(_P3_5);
			exit;
		end;
	end;
	_P3_5_old := wrk.bitg(_P3_5);
	while iclock > 0
	do begin
		case m1 of
		0:				// 13 bit zhler, bei atlp 9-16 bit
			begin
				inc(tl1);
				if (tl1 and pm1) = 0
				then begin
					inc(th1);
					if (th1 = 0)
					and (m0 <> 3)
					then begin
						wrk.bitm(_TF1, true);			// interrupt
//						tim.tag := _TF1;
					end;
				end;
			end;
		1:				// 16 bit zhler, bei atlp... reload
			begin
				inc(tl1);
				if tl1 = 0
				then begin
					inc(th1);
					if th1 = 0
					then begin
						if wrk.sfrd[_RH1]					// reload ???
						then begin
							th1 := wrk.sfrs[_RH1];
							tl1 := wrk.sfrs[_RL1];
						end;
						if (m0 <> 3)
						then begin
							wrk.bitm(_TF1, true);			// interrupt
//							tim.tag := _TF1;
							if wrk.scow > 0
							then serial;
						end;
					end;
				end;
			end;
		2:				// 8 bit auto reload
			begin
				inc(tl1);
				if tl1 = 0
				then begin
					tl1 := th1;								// reload;
					if (m0 <> 3)
					then begin
						wrk.bitm(_TF1, true);			// interrupt
//						tim.tag := _TF1;
					end;
					if wrk.scow > 0
					then serial;
				end;
			end;
		4:				// n + 8 bit zhler PWM
			begin
				inc(tl1);
				if tl1 and pm0 = 0
				then begin
					tl1 := 0;
					inc(th1);
					if th1 = 0
					then begin
						o1 := wrk.sfrs[_RH1];
						if (o1 > 0)
						and v1
						then wrk.bitm(_P3_5, true);
					end;
					if th1 = o1
					then begin
						if v1
						then wrk.bitm(_P3_5, false);
					end;
				end;
			end;
		5:					// 8 + 8 bit zhler PWM
			begin
				inc(tl1);
				if tl1 = 0
				then begin
					tl1 := wrk.sfrs[_RL1];
					inc(th1);
					if th1 = 0
					then begin
						o1 := wrk.sfrs[_RH1];
						if (o1 > 0)
						and v1
						then wrk.bitm(_P3_5, true);
					end;
					if th1 = o1
					then begin
						if v1
						then wrk.bitm(_P3_5, false);
					end;
				end;
			end;
		end;
		dec(iclock);
	end;
	wrk.ssfr(_TL1, tl1);
	wrk.ssfr(_TH1, th1);
end;

end.
